#ifndef SBK_CALSTORAGEWRAPPER_H
#define SBK_CALSTORAGEWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <calstorage.h>

#include <sbkpython.h>

#include <array>
namespace Shiboken { struct AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class CalStorageWrapper : public KCalendarCore::CalStorage
{
public:
    CalStorageWrapper(const CalStorageWrapper &) = delete;
    CalStorageWrapper& operator=(const CalStorageWrapper &) = delete;
    CalStorageWrapper(CalStorageWrapper &&) = delete;
    CalStorageWrapper& operator=(CalStorageWrapper &&) = delete;
    ~CalStorageWrapper() override;

    void childEvent(::QChildEvent * event) override;
    bool close() override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    bool load() override;
    bool open() override;
    bool save() override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable std::array<PyObject *, 11> m_PyMethodCache = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};
};

#endif // SBK_CALSTORAGEWRAPPER_H
